
/*  List of GNODE-objects 
 *  ---------------------
 *  These are used for various reasons: as list of nodes of a (sub)graph,
 *  as lists of nodes of a region, etc.
 */

typedef struct gnlist {
	struct gnode 	*node;           /* The node              */
	struct gnlist 	*next;           /* The remaining list    */
	struct gnlist	*internal_next;  /* For memory management */
} *GNLIST;

#define	GNNODE(x)	((x)->node)
#define	GNNEXT(x)	((x)->next)
#define	GNINTERN(x)	((x)->internal_next)

/* end. */
