
/*
 *  This program and documentation is free software; you can redistribute 
 *  it under the terms of the  GNU General Public License as published by
 *  the  Free Software Foundation;  either version 2  of the License,  or
 *  (at your option) any later version.
 *
 *  This  program  is  distributed  in  the hope that it will be useful,
 *  but  WITHOUT ANY WARRANTY;  without  even  the  implied  warranty of
 *  MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy of the GNU General Public License
 *  along  with  this  program;  if  not,  write  to  the  Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

VCG_T_Co(T_Co_index_val,0,0) /* index_val */
VCG_T_Co(T_Co_stern,1,1) /* stern */
VCG_T_Co(T_Co_range,2,2) /* range */
VCG_T_Co(T_Co_index,3,2) /* index */
VCG_T_Co(T_Co_index_value,4,2) /* index_value */
VCG_T_Co(T_Co_string,5,0) /* string */
VCG_T_Co(T_Co_char,6,0) /* char */
VCG_T_Co(T_Co_float,7,0) /* float */
VCG_T_Co(T_Co_integer,8,0) /* integer */
VCG_T_Co(T_Co_z,9,0) /* z */
VCG_T_Co(T_Co_y,10,0) /* y */
VCG_T_Co(T_Co_x,11,0) /* x */
VCG_T_Co(T_Co_right_neighbor,12,0) /* right_neighbor */
VCG_T_Co(T_Co_left_neighbor,13,0) /* left_neighbor */
VCG_T_Co(T_Co_lower_neighbor,14,0) /* lower_neighbor */
VCG_T_Co(T_Co_upper_neighbor,15,0) /* upper_neighbor */
VCG_T_Co(T_Co_right_margin,16,0) /* right_margin */
VCG_T_Co(T_Co_left_margin,17,0) /* left_margin */
VCG_T_Co(T_Co_bottom_margin,18,0) /* bottom_margin */
VCG_T_Co(T_Co_top_margin,19,0) /* top_margin */
VCG_T_Co(T_Co_equal_column,20,0) /* equal_column */
VCG_T_Co(T_Co_equal_row,21,0) /* equal_row */
VCG_T_Co(T_Co_equal_position,22,0) /* equal_position */
VCG_T_Co(T_Co_behind,23,0) /* behind */
VCG_T_Co(T_Co_in_font,24,0) /* in_font */
VCG_T_Co(T_Co_right,25,0) /* right */
VCG_T_Co(T_Co_left,26,0) /* left */
VCG_T_Co(T_Co_below,27,0) /* below */
VCG_T_Co(T_Co_above,28,0) /* above */
VCG_T_Co(T_Co_limit,29,0) /* limit */
VCG_T_Co(T_Co_cluster,30,0) /* cluster */
VCG_T_Co(T_Co_xrange,31,0) /* xrange */
VCG_T_Co(T_Co_high_margin,32,0) /* high_margin */
VCG_T_Co(T_Co_low_margin,33,0) /* low_margin */
VCG_T_Co(T_Co_neighbors,34,0) /* neighbors */
VCG_T_Co(T_Co_greater,35,0) /* greater */
VCG_T_Co(T_Co_smaller,36,0) /* smaller */
VCG_T_Co(T_Co_equal,37,0) /* equal */
VCG_T_Co(T_Co_string_array,38,2) /* string_array */
VCG_T_Co(T_Co_dimension,39,1) /* dimension */
VCG_T_Co(T_Co_name,40,1) /* name */
VCG_T_Co(T_Co_interval,41,1) /* interval */
VCG_T_Co(T_Co_nodes,42,1) /* nodes */
VCG_T_Co(T_Co_size,43,1) /* size */
VCG_T_Co(T_Co_solid,44,0) /* solid */
VCG_T_Co(T_Co_line,45,0) /* line */
VCG_T_Co(T_Co_none,46,0) /* none */
VCG_T_Co(T_Co_invisible,47,0) /* invisible */
VCG_T_Co(T_Co_dashed,48,0) /* dashed */
VCG_T_Co(T_Co_dotted,49,0) /* dotted */
VCG_T_Co(T_Co_continuous,50,0) /* continuous */
VCG_T_Co(T_Co_anchor,51,1) /* anchor */
VCG_T_Co(T_Co_linestyle,52,1) /* linestyle */
VCG_T_Co(T_Co_barrowstyle,53,1) /* barrowstyle */
VCG_T_Co(T_Co_arrowstyle,54,1) /* arrowstyle */
VCG_T_Co(T_Co_barrowsize,55,1) /* barrowsize */
VCG_T_Co(T_Co_arrowsize,56,1) /* arrowsize */
VCG_T_Co(T_Co_barrowcolor,57,1) /* barrowcolor */
VCG_T_Co(T_Co_arrowcolor,58,1) /* arrowcolor */
VCG_T_Co(T_Co_arrowheight,59,1) /* arrowheight */
VCG_T_Co(T_Co_arrowwidth,60,1) /* arrowwidth */
VCG_T_Co(T_Co_priority,61,1) /* priority */
VCG_T_Co(T_Co_class,62,1) /* class */
VCG_T_Co(T_Co_thickness,63,1) /* thickness */
VCG_T_Co(T_Co_targetname,64,1) /* targetname */
VCG_T_Co(T_Co_sourcename,65,1) /* sourcename */
VCG_T_Co(T_Co_around,66,0) /* around */
VCG_T_Co(T_Co_top,67,0) /* top */
VCG_T_Co(T_Co_bottom,68,0) /* bottom */
VCG_T_Co(T_Co_triangle,69,0) /* triangle */
VCG_T_Co(T_Co_ellipse,70,0) /* ellipse */
VCG_T_Co(T_Co_rhomb,71,0) /* rhomb */
VCG_T_Co(T_Co_box,72,0) /* box */
VCG_T_Co(T_Co_right_justify,73,0) /* right_justify */
VCG_T_Co(T_Co_left_justify,74,0) /* left_justify */
VCG_T_Co(T_Co_center,75,0) /* center */
VCG_T_Co(T_Co_iconstyle,76,1) /* iconstyle */
VCG_T_Co(T_Co_iconheight,77,1) /* iconheight */
VCG_T_Co(T_Co_iconwidth,78,1) /* iconwidth */
VCG_T_Co(T_Co_anchorpoints,79,1) /* anchorpoints */
VCG_T_Co(T_Co_iconfile,80,1) /* iconfile */
VCG_T_Co(T_Co_bordercolor,81,1) /* bordercolor */
VCG_T_Co(T_Co_fontname,82,1) /* fontname */
VCG_T_Co(T_Co_constraint_attribute,83,2) /* constraint_attribute */
VCG_T_Co(T_Co_edge_attribute,84,2) /* edge_attribute */
VCG_T_Co(T_Co_node_attribute,85,2) /* node_attribute */
VCG_T_Co(T_Co_free,86,0) /* free */
VCG_T_Co(T_Co_fixed,87,0) /* fixed */
VCG_T_Co(T_Co_fpfish,88,0) /* fpfish */
VCG_T_Co(T_Co_pfish,89,0) /* pfish */
VCG_T_Co(T_Co_fcfish,90,0) /* fcfish */
VCG_T_Co(T_Co_cfish,91,0) /* cfish */
VCG_T_Co(T_Co_medianbary,92,0) /* medianbary */
VCG_T_Co(T_Co_barymedian,93,0) /* barymedian */
VCG_T_Co(T_Co_median,94,0) /* median */
VCG_T_Co(T_Co_bary,95,0) /* bary */
VCG_T_Co(T_Co_no,96,0) /* no */
VCG_T_Co(T_Co_yes,97,0) /* yes */
VCG_T_Co(T_Co_grey,98,0) /* grey */
VCG_T_Co(T_Co_manual,99,0) /* manual */
VCG_T_Co(T_Co_every,100,0) /* every */
VCG_T_Co(T_Co_depthfirst,101,0) /* depthfirst */
VCG_T_Co(T_Co_minbackwards,102,0) /* minbackwards */
VCG_T_Co(T_Co_minoutdegree,103,0) /* minoutdegree */
VCG_T_Co(T_Co_maxoutdegree,104,0) /* maxoutdegree */
VCG_T_Co(T_Co_minindegree,105,0) /* minindegree */
VCG_T_Co(T_Co_maxindegree,106,0) /* maxindegree */
VCG_T_Co(T_Co_mindegree,107,0) /* mindegree */
VCG_T_Co(T_Co_maxdegree,108,0) /* maxdegree */
VCG_T_Co(T_Co_mindepthslow,109,0) /* mindepthslow */
VCG_T_Co(T_Co_maxdepthslow,110,0) /* maxdepthslow */
VCG_T_Co(T_Co_mindepth,111,0) /* mindepth */
VCG_T_Co(T_Co_maxdepth,112,0) /* maxdepth */
VCG_T_Co(T_Co_tree,113,0) /* tree */
VCG_T_Co(T_Co_constaints,114,0) /* constaints */
VCG_T_Co(T_Co_planar,115,0) /* planar */
VCG_T_Co(T_Co_isi,116,0) /* isi */
VCG_T_Co(T_Co_barycenter,117,0) /* barycenter */
VCG_T_Co(T_Co_right_to_left,118,0) /* right_to_left */
VCG_T_Co(T_Co_left_to_right,119,0) /* left_to_right */
VCG_T_Co(T_Co_bottom_to_top,120,0) /* bottom_to_top */
VCG_T_Co(T_Co_top_to_bottom,121,0) /* top_to_bottom */
VCG_T_Co(T_Co_low,122,0) /* low */
VCG_T_Co(T_Co_high,123,0) /* high */
VCG_T_Co(T_Co_colindex,124,1) /* colindex */
VCG_T_Co(T_Co_yellowgreen,125,0) /* yellowgreen */
VCG_T_Co(T_Co_yellow,126,0) /* yellow */
VCG_T_Co(T_Co_white,127,0) /* white */
VCG_T_Co(T_Co_turquoise,128,0) /* turquoise */
VCG_T_Co(T_Co_red,129,0) /* red */
VCG_T_Co(T_Co_purple,130,0) /* purple */
VCG_T_Co(T_Co_pink,131,0) /* pink */
VCG_T_Co(T_Co_orchid,132,0) /* orchid */
VCG_T_Co(T_Co_orange,133,0) /* orange */
VCG_T_Co(T_Co_magenta,134,0) /* magenta */
VCG_T_Co(T_Co_lilac,135,0) /* lilac */
VCG_T_Co(T_Co_lightyellow,136,0) /* lightyellow */
VCG_T_Co(T_Co_lightred,137,0) /* lightred */
VCG_T_Co(T_Co_lightmagenta,138,0) /* lightmagenta */
VCG_T_Co(T_Co_lightgrey,139,0) /* lightgrey */
VCG_T_Co(T_Co_lightgreen,140,0) /* lightgreen */
VCG_T_Co(T_Co_lightcyan,141,0) /* lightcyan */
VCG_T_Co(T_Co_lightblue,142,0) /* lightblue */
VCG_T_Co(T_Co_khaki,143,0) /* khaki */
VCG_T_Co(T_Co_green,144,0) /* green */
VCG_T_Co(T_Co_gold,145,0) /* gold */
VCG_T_Co(T_Co_darkyellow,146,0) /* darkyellow */
VCG_T_Co(T_Co_darkred,147,0) /* darkred */
VCG_T_Co(T_Co_darkmagenta,148,0) /* darkmagenta */
VCG_T_Co(T_Co_darkgrey,149,0) /* darkgrey */	
VCG_T_Co(T_Co_darkgreen,150,0) /* darkgreen */
VCG_T_Co(T_Co_darkcyan,151,0) /* darkcyan */
VCG_T_Co(T_Co_darkblue,152,0) /* darkblue */
VCG_T_Co(T_Co_cyan,153,0) /* cyan */
VCG_T_Co(T_Co_blue,154,0) /* blue */
VCG_T_Co(T_Co_black,155,0) /* black */
VCG_T_Co(T_Co_aquamarine,156,0) /* aquamarine */
VCG_T_Co(T_Co_yscrollbar,157,1) /* yscrollbar */
VCG_T_Co(T_Co_xscrollbar,158,1) /* xscrollbar */
VCG_T_Co(T_Co_outputfunction,159,1) /* outputfunction */
VCG_T_Co(T_Co_inputfunction,160,1) /* inputfunction */
VCG_T_Co(T_Co_topsort,161,1) /* topsort */
VCG_T_Co(T_Co_layoutparameter,162,1) /* layoutparameter */
VCG_T_Co(T_Co_include,163,1) /* include */
VCG_T_Co(T_Co_typename,164,1) /* typename */
VCG_T_Co(T_Co_straight_max,165,1) /* straight_max */
VCG_T_Co(T_Co_rubber_min,166,1) /* rubber_min */
VCG_T_Co(T_Co_rubber_max,167,1) /* rubber_max */
VCG_T_Co(T_Co_pendel_min,168,1) /* pendel_min */
VCG_T_Co(T_Co_pendel_max,169,1) /* pendel_max */
VCG_T_Co(T_Co_cross_min,170,1) /* cross_min */
VCG_T_Co(T_Co_cross_max,171,1) /* cross_max */
VCG_T_Co(T_Co_bend_max,172,1) /* bend_max */
VCG_T_Co(T_Co_view_splines,173,1) /* view_splines */
VCG_T_Co(T_Co_view_nodes,174,1) /* view_nodes */
VCG_T_Co(T_Co_view_edges,175,1) /* view_edges */
VCG_T_Co(T_Co_view_method,176,1) /* view_method */
VCG_T_Co(T_Co_crossing_weight,177,1) /* crossing_weight */
VCG_T_Co(T_Co_crossing_opt,178,1) /* crossing_opt */
VCG_T_Co(T_Co_crossing_phase2,179,1) /* crossing_phase2 */
VCG_T_Co(T_Co_treefactor,180,1) /* treefactor */
VCG_T_Co(T_Co_spreadlevel,181,1) /* spreadlevel */
VCG_T_Co(T_Co_arrow_mode,182,1) /* arrow_mode */
VCG_T_Co(T_Co_port_sharing,183,1) /* port_sharing */
VCG_T_Co(T_Co_node_alignment,184,1) /* node_alignment */
VCG_T_Co(T_Co_orientation,185,1) /* orientation */
VCG_T_Co(T_Co_dummy,186,0) /* dummy */
VCG_T_Co(T_Co_nonearedges,187,0) /* nonearedges */
VCG_T_Co(T_Co_smanhatten,188,1) /* smanhatten */
VCG_T_Co(T_Co_manhatten,189,1) /* manhatten */
VCG_T_Co(T_Co_priophase,190,1) /* priophase */
VCG_T_Co(T_Co_straightphase,191,1) /* straightphase */
VCG_T_Co(T_Co_hidesingles,192,1) /* hidesingles */
VCG_T_Co(T_Co_finetuning,193,1) /* finetuning */
VCG_T_Co(T_Co_dirty_edge_label,194,1) /* dirty_edge_label */
VCG_T_Co(T_Co_display_edge_label,195,1) /* display_edge_label */
VCG_T_Co(T_Co_late_edge_label,196,1) /* late_edge_label */
VCG_T_Co(T_Co_splinefactor,197,1) /* splinefactor */
VCG_T_Co(T_Co_nearfactor,198,1) /* nearfactor */
VCG_T_Co(T_Co_upfactor,199,1) /* upfactor */
VCG_T_Co(T_Co_downfactor,200,1) /* downfactor */
VCG_T_Co(T_Co_layoutfrequency,201,1) /* layoutfrequency */
VCG_T_Co(T_Co_layoutalgorithm,202,1) /* layoutalgorithm */
VCG_T_Co(T_Co_colentry,203,4) /* colentry */
VCG_T_Co(T_Co_infoname,204,2) /* infoname */
VCG_T_Co(T_Co_classname,205,2) /* classname */
VCG_T_Co(T_Co_hidden,206,1) /* hidden */
VCG_T_Co(T_Co_yraster,207,1) /* yraster */
VCG_T_Co(T_Co_xlraster,208,1) /* xlraster */
VCG_T_Co(T_Co_xraster,209,1) /* xraster */
VCG_T_Co(T_Co_yspace,210,1) /* yspace */
VCG_T_Co(T_Co_xlspace,211,1) /* xlspace */
VCG_T_Co(T_Co_xspace,212,1) /* xspace */
VCG_T_Co(T_Co_ybase,213,1) /* ybase */
VCG_T_Co(T_Co_xbase,214,1) /* xbase */
VCG_T_Co(T_Co_ymax,215,1) /* ymax */
VCG_T_Co(T_Co_xmax,216,1) /* xmax */
VCG_T_Co(T_Co_status,217,1) /* status */
VCG_T_Co(T_Co_horizontal_order,218,1) /* horizontal_order */
VCG_T_Co(T_Co_level,219,1) /* level */
VCG_T_Co(T_Co_shape,220,1) /* shape */
VCG_T_Co(T_Co_textmode,221,1) /* textmode */
VCG_T_Co(T_Co_stretch,222,1) /* stretch */
VCG_T_Co(T_Co_shrink,223,1) /* shrink */
VCG_T_Co(T_Co_scaling,224,1) /* scaling */
VCG_T_Co(T_Co_folding,225,1) /* folding */
VCG_T_Co(T_Co_loc,226,2) /* loc */
VCG_T_Co(T_Co_ydef,227,1) /* ydef */
VCG_T_Co(T_Co_xdef,228,1) /* xdef */
VCG_T_Co(T_Co_borderwidth,229,1) /* borderwidth */
VCG_T_Co(T_Co_height,230,1) /* height */
VCG_T_Co(T_Co_width,231,1) /* width */
VCG_T_Co(T_Co_colorborder,232,1) /* colorborder */
VCG_T_Co(T_Co_textcolor,233,1) /* textcolor */
VCG_T_Co(T_Co_color,234,1) /* color */
VCG_T_Co(T_Co_info3,235,1) /* info3 */
VCG_T_Co(T_Co_info2,236,1) /* info2 */
VCG_T_Co(T_Co_info1,237,1) /* info1 */
VCG_T_Co(T_Co_label,238,1) /* label */
VCG_T_Co(T_Co_title,239,1) /* title */
VCG_T_Co(T_Co_constraint,240,1) /* constraint */
VCG_T_Co(T_Co_back_edge,241,1) /* back_edge */
VCG_T_Co(T_Co_bent_near_edge,242,1) /* bent_near_edge */
VCG_T_Co(T_Co_near_edge,243,1) /* near_edge */
VCG_T_Co(T_Co_edge,244,1) /* edge */
VCG_T_Co(T_Co_node,245,1) /* node */
VCG_T_Co(T_Co_graph,246,1) /* graph */
VCG_T_Co(T_Co_foldedge_defaults,247,1) /* foldedge_defaults */
VCG_T_Co(T_Co_foldnode_defaults,248,1) /* foldnode_defaults */
VCG_T_Co(T_Co_edge_defaults,249,1) /* edge_defaults */
VCG_T_Co(T_Co_node_defaults,250,1) /* node_defaults */
VCG_T_Co(T_Co_graph_attribute,251,1) /* graph_attribute */
VCG_T_Co(T_Co_graph_entry,252,2) /* graph_entry */
VCG_T_Co(T_Co_url,253,1) /* url node/edge */
