
/*  Dllists
 *  -------
 *  To calculate the number of crossings, we use a plain sweep algorithm
 *  that uses two lists. These sets are implemented as double
 *  linked lists containing nodes.
 */

typedef	struct dllist {
	struct	gnode	*node;		/* the node              */
	int		dlinfo;		/* the node info	 */
	int		dlx;		/* the info coordinate   */
	struct	dllist	*pred;          /* predecessor cons cell */
	struct	dllist	*succ;          /* successor   cons cell */
} *DLLIST;

#define	DPRED(x)	((x)->pred)
#define	DSUCC(x)	((x)->succ)
#define	DNODE(x)	((x)->node)
#define	DNX(x)		((x)->dlx)
#define	DINFO(x)	((x)->dlinfo)

/* end. */
